import { IItem,IListItem } from '@farmmaps/common';
import {Layer} from 'ol/layer';

export interface IItemLayer  {
  item: IItem,
  layer: Layer,
  visible: boolean,
  legendVisible:boolean,
  projection: string,
  opacity: number,
  layerIndex:number
}

export class ItemLayer implements IItemLayer {
  public item: IItem;
  public layer: Layer = null;
  public visible: boolean = true;
  public legendVisible: boolean = false;
  public projection: string;
  public opacity: number = 1;
  public layerIndex: number = -1;

  constructor(item:IItem) {
    this.item = item;
  }
}

export interface ITemporalItemLayer extends IItemLayer {
  previousItemLayer: IItemLayer,
  selectedItemLayer: IItemLayer,
  nextItemLayer: IItemLayer,
  temporalItems: IItem[],
}

export class TemporalItemLayer extends ItemLayer implements ITemporalItemLayer {
  public previousItemLayer:IItemLayer = null;
  public selectedItemLayer:IItemLayer =null;
  public nextItemLayer:IItemLayer = null;
  public temporalItems:IItem[] = [];

  constructor(item:IItem) {
   super(item)
  }
}



